summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorGalen Guyer <galen@galenguyer.com>2022-08-21 18:24:35 -0400
committerGalen Guyer <galen@galenguyer.com>2022-08-21 18:24:35 -0400
commitf668e009263cdafdebae3607719ae19bfd9dc249 (patch)
treeb9379edfa40b18c237eb7d38e6a2af8e0829028a
parent36fbe057d2235cbc12c3e7e85d88486d02be6c12 (diff)
begin configuration of new machine
-rwxr-xr-xdots2
-rw-r--r--modules/10-i3/config194
-rw-r--r--modules/10-i3/install.sh45
-rw-r--r--modules/10-i3/xinitrc35
-rw-r--r--modules/10-ssh/install.sh2
-rw-r--r--modules/20-alacritty/install.sh29
-rw-r--r--modules/20-fonts/install.sh10
-rw-r--r--modules/30-rust/install.sh16
-rw-r--r--modules/40-neofetch/install.sh1
9 files changed, 332 insertions, 2 deletions
diff --git a/dots b/dots
index 9a4d9fa..4ae4d48 100755
--- a/dots
+++ b/dots
@@ -22,7 +22,7 @@ EOF
function main() {
intro
- MODULES=modules/**/install.sh
+ MODULES=modules/**$1/install.sh
# perform preinstall tasks
PACKAGES=()
diff --git a/modules/10-i3/config b/modules/10-i3/config
new file mode 100644
index 0000000..9595b9d
--- /dev/null
+++ b/modules/10-i3/config
@@ -0,0 +1,194 @@
+# This file has been auto-generated by i3-config-wizard(1).
+# It will not be overwritten, so edit it as you like.
+#
+# Should you change your keyboard layout some time, delete
+# this file and re-run i3-config-wizard(1).
+#
+
+# i3 config file (v4)
+#
+# Please see https://i3wm.org/docs/userguide.html for a complete reference!
+
+set $mod Mod4
+
+# Font for window titles. Will also be used by the bar unless a different font
+# is used in the bar {} block below.
+font pango:monospace 8
+
+# This font is widely installed, provides lots of unicode glyphs, right-to-left
+# text rendering and scalability on retina/hidpi displays (thanks to pango).
+#font pango:DejaVu Sans Mono 8
+
+# Hide window borders
+for_window [class="^.*"] border pixel 0
+hide_edge_borders smart
+
+# Start XDG autostart .desktop files using dex. See also
+# https://wiki.archlinux.org/index.php/XDG_Autostart
+exec --no-startup-id dex --autostart --environment i3
+
+# The combination of xss-lock, nm-applet and pactl is a popular choice, so
+# they are included here as an example. Modify as you see fit.
+
+# xss-lock grabs a logind suspend inhibit lock and will use i3lock to lock the
+# screen before suspend. Use loginctl lock-session to lock your screen.
+exec --no-startup-id xss-lock --transfer-sleep-lock -- ~/.dots/ext/lock.sh
+
+# NetworkManager is the most popular way to manage wireless networks on Linux,
+# and nm-applet is a desktop environment-independent system tray GUI for it.
+exec --no-startup-id nm-applet
+
+# Use pactl to adjust volume in PulseAudio.
+set $refresh_i3status killall -SIGUSR1 i3status
+bindsym XF86AudioRaiseVolume exec --no-startup-id pactl set-sink-volume @DEFAULT_SINK@ +10% && $refresh_i3status
+bindsym XF86AudioLowerVolume exec --no-startup-id pactl set-sink-volume @DEFAULT_SINK@ -10% && $refresh_i3status
+bindsym XF86AudioMute exec --no-startup-id pactl set-sink-mute @DEFAULT_SINK@ toggle && $refresh_i3status
+bindsym XF86AudioMicMute exec --no-startup-id pactl set-source-mute @DEFAULT_SOURCE@ toggle && $refresh_i3status
+
+# Use Mouse+$mod to drag floating windows to their wanted position
+floating_modifier $mod
+
+# start a terminal
+bindsym $mod+Return exec alacritty
+
+# kill focused window
+bindsym $mod+Shift+q kill
+
+# lock the screen
+#bindsym $mod+q exec i3lock --nofork --color 000000 --show-failed-attempts
+bindsym $mod+q exec loginctl lock-session
+
+# start dmenu (a program launcher)
+bindsym $mod+d exec --no-startup-id dmenu_run
+# A more modern dmenu replacement is rofi:
+# bindcode $mod+40 exec "rofi -modi drun,run -show drun"
+# There also is i3-dmenu-desktop which only displays applications shipping a
+# .desktop file. It is a wrapper around dmenu, so you need that installed.
+# bindcode $mod+40 exec --no-startup-id i3-dmenu-desktop
+
+# change focus
+bindsym $mod+j focus left
+bindsym $mod+k focus down
+bindsym $mod+l focus up
+bindsym $mod+semicolon focus right
+
+# alternatively, you can use the cursor keys:
+bindsym $mod+Left focus left
+bindsym $mod+Down focus down
+bindsym $mod+Up focus up
+bindsym $mod+Right focus right
+
+# move focused window
+bindsym $mod+Shift+j move left
+bindsym $mod+Shift+k move down
+bindsym $mod+Shift+l move up
+bindsym $mod+Shift+semicolon move right
+
+# alternatively, you can use the cursor keys:
+bindsym $mod+Shift+Left move left
+bindsym $mod+Shift+Down move down
+bindsym $mod+Shift+Up move up
+bindsym $mod+Shift+Right move right
+
+# split in horizontal orientation
+bindsym $mod+h split h
+
+# split in vertical orientation
+bindsym $mod+v split v
+
+# enter fullscreen mode for the focused container
+bindsym $mod+f fullscreen toggle
+
+# change container layout (stacked, tabbed, toggle split)
+bindsym $mod+s layout stacking
+bindsym $mod+w layout tabbed
+bindsym $mod+e layout toggle split
+
+# toggle tiling / floating
+bindsym $mod+Shift+space floating toggle
+
+# change focus between tiling / floating windows
+bindsym $mod+space focus mode_toggle
+
+# focus the parent container
+bindsym $mod+a focus parent
+
+# focus the child container
+#bindsym $mod+d focus child
+
+# Define names for default workspaces for which we configure key bindings later on.
+# We use variables to avoid repeating the names in multiple places.
+set $ws1 "1"
+set $ws2 "2"
+set $ws3 "3"
+set $ws4 "4"
+set $ws5 "5"
+set $ws6 "6"
+set $ws7 "7"
+set $ws8 "8"
+set $ws9 "9"
+set $ws10 "10"
+
+# switch to workspace
+bindsym $mod+1 workspace number $ws1
+bindsym $mod+2 workspace number $ws2
+bindsym $mod+3 workspace number $ws3
+bindsym $mod+4 workspace number $ws4
+bindsym $mod+5 workspace number $ws5
+bindsym $mod+6 workspace number $ws6
+bindsym $mod+7 workspace number $ws7
+bindsym $mod+8 workspace number $ws8
+bindsym $mod+9 workspace number $ws9
+bindsym $mod+0 workspace number $ws10
+
+# move focused container to workspace
+bindsym $mod+Shift+1 move container to workspace number $ws1
+bindsym $mod+Shift+2 move container to workspace number $ws2
+bindsym $mod+Shift+3 move container to workspace number $ws3
+bindsym $mod+Shift+4 move container to workspace number $ws4
+bindsym $mod+Shift+5 move container to workspace number $ws5
+bindsym $mod+Shift+6 move container to workspace number $ws6
+bindsym $mod+Shift+7 move container to workspace number $ws7
+bindsym $mod+Shift+8 move container to workspace number $ws8
+bindsym $mod+Shift+9 move container to workspace number $ws9
+bindsym $mod+Shift+0 move container to workspace number $ws10
+
+# reload the configuration file
+bindsym $mod+Shift+c reload
+# restart i3 inplace (preserves your layout/session, can be used to upgrade i3)
+bindsym $mod+Shift+r restart
+# exit i3 (logs you out of your X session)
+bindsym $mod+Shift+e exec "i3-nagbar -t warning -m 'You pressed the exit shortcut. Do you really want to exit i3? This will end your X session.' -B 'Yes, exit i3' 'i3-msg exit'"
+
+# resize window (you can also use the mouse for that)
+mode "resize" {
+ # These bindings trigger as soon as you enter the resize mode
+
+ # Pressing left will shrink the window’s width.
+ # Pressing right will grow the window’s width.
+ # Pressing up will shrink the window’s height.
+ # Pressing down will grow the window’s height.
+ bindsym j resize shrink width 10 px or 10 ppt
+ bindsym k resize grow height 10 px or 10 ppt
+ bindsym l resize shrink height 10 px or 10 ppt
+ bindsym semicolon resize grow width 10 px or 10 ppt
+
+ # same bindings, but for the arrow keys
+ bindsym Left resize shrink width 10 px or 10 ppt
+ bindsym Down resize grow height 10 px or 10 ppt
+ bindsym Up resize shrink height 10 px or 10 ppt
+ bindsym Right resize grow width 10 px or 10 ppt
+
+ # back to normal: Enter or Escape or $mod+r
+ bindsym Return mode "default"
+ bindsym Escape mode "default"
+ bindsym $mod+r mode "default"
+}
+
+bindsym $mod+r mode "resize"
+
+# Start i3bar to display a workspace bar (plus the system information i3status
+# finds out, if available)
+bar {
+ status_command i3status
+}
diff --git a/modules/10-i3/install.sh b/modules/10-i3/install.sh
new file mode 100644
index 0000000..5f6ab71
--- /dev/null
+++ b/modules/10-i3/install.sh
@@ -0,0 +1,45 @@
+_script="$(realpath ${BASH_SOURCE[0]})"
+_scriptname="$(basename $_script)"
+_scriptdir="$(dirname $_script)"
+_modulename="$(basename $_scriptdir)"
+DOT_MODULE_NAME="i3"
+
+function preinstall() {
+ if ! [[ -x "$(command -v i3)" ]]; then
+ PACKAGES+=("i3-gaps")
+ fi
+ if ! [[ -x "$(command -v i3lock)" ]]; then
+ PACKAGES+=("i3lock" "polkit")
+ fi
+ if ! [[ -x "$(command -v dmenu)" ]]; then
+ PACKAGES+=("dmenu")
+ fi
+ if ! [[ -x "$(command -v startx)" ]]; then
+ PACKAGES+=("xorg" "xorg-xinit")
+ fi
+ if ! [[ -x "$(command -v xss-lock)" ]]; then
+ PACKAGES+=("xss-lock")
+ fi
+ if ! [[ -x "$(command -v scrot)" ]]; then
+ PACKAGES+=("scrot")
+ fi
+ if ! [[ -x "$(command -v convert)" ]]; then
+ PACKAGES+=("imagemagick")
+ fi
+}
+
+function install() {
+ # backup old file if it exists and we haven't backed it up before
+ if [[ -f "$HOME/.config/i3/config" ]] && ! [[ -f "$HOME/.config/i3/config.bak" ]] && ! [[ -f "$_scriptdir/.firstrun" ]]; then
+ log verbose "making backup"
+ cp "$HOME/.config/i3/config" "$HOME/.config/i3/config.bak"
+ touch "$_scriptdir/.firstrun"
+ fi
+
+ log info "linking i3 config"
+ mkdir -p "$HOME/.config/i3"
+ ln -f "$_scriptdir/config" "$HOME/.config/i3/config"
+
+ log info "linking xinitrc"
+ ln -f "$_scriptdir/xinitrc" "$HOME/.xinitrc"
+}
diff --git a/modules/10-i3/xinitrc b/modules/10-i3/xinitrc
new file mode 100644
index 0000000..3da89d0
--- /dev/null
+++ b/modules/10-i3/xinitrc
@@ -0,0 +1,35 @@
+#!/bin/sh
+
+userresources=$HOME/.Xresources
+usermodmap=$HOME/.Xmodmap
+sysresources=/etc/X11/xinit/.Xresources
+sysmodmap=/etc/X11/xinit/.Xmodmap
+
+# merge in defaults and keymaps
+
+if [ -f $sysresources ]; then
+ xrdb -merge $sysresources
+fi
+
+if [ -f $sysmodmap ]; then
+ xmodmap $sysmodmap
+fi
+
+if [ -f "$userresources" ]; then
+ xrdb -merge "$userresources"
+fi
+
+if [ -f "$usermodmap" ]; then
+ xmodmap "$usermodmap"
+fi
+
+# start some nice programs
+
+if [ -d /etc/X11/xinit/xinitrc.d ] ; then
+ for f in /etc/X11/xinit/xinitrc.d/?*.sh ; do
+ [ -x "$f" ] && . "$f"
+ done
+ unset f
+fi
+
+exec i3
diff --git a/modules/10-ssh/install.sh b/modules/10-ssh/install.sh
index 8fb3145..7799fd8 100644
--- a/modules/10-ssh/install.sh
+++ b/modules/10-ssh/install.sh
@@ -13,7 +13,7 @@ function preinstall() {
fi
}
-function install() {
+function _install() {
git-crypt unlock
if [[ "$?" -ne "0" ]]; then
diff --git a/modules/20-alacritty/install.sh b/modules/20-alacritty/install.sh
new file mode 100644
index 0000000..0cb7f22
--- /dev/null
+++ b/modules/20-alacritty/install.sh
@@ -0,0 +1,29 @@
+_script="$(realpath ${BASH_SOURCE[0]})"
+_scriptname="$(basename $_script)"
+_scriptdir="$(dirname $_script)"
+_modulename="$(basename $_scriptdir)"
+DOT_MODULE_NAME="i3"
+
+function preinstall() {
+ if ! [[ -x "$(command -v alacritty)" ]]; then
+ PACKAGES+=("alacritty")
+ fi
+}
+
+function install() {
+ return
+
+ # backup old file if it exists and we haven't backed it up before
+ if [[ -f "$HOME/.config/i3/config" ]] && ! [[ -f "$HOME/.config/i3/config.bak" ]] && ! [[ -f "$_scriptdir/.firstrun" ]]; then
+ log verbose "making backup"
+ cp "$HOME/.config/i3/config" "$HOME/.config/i3/config.bak"
+ touch "$_scriptdir/.firstrun"
+ fi
+
+ log info "linking i3 config"
+ mkdir -p "$HOME/.config/i3"
+ ln -f "$_scriptdir/config" "$HOME/.config/i3/config"
+
+ log info "linking xinitrc"
+ ln -f "$_scriptdir/xinitrc" "$HOME/.xinitrc"
+}
diff --git a/modules/20-fonts/install.sh b/modules/20-fonts/install.sh
new file mode 100644
index 0000000..c34fb5f
--- /dev/null
+++ b/modules/20-fonts/install.sh
@@ -0,0 +1,10 @@
+_script="$(realpath ${BASH_SOURCE[0]})"
+_scriptname="$(basename $_script)"
+_scriptdir="$(dirname $_script)"
+_modulename="$(basename $_scriptdir)"
+DOT_MODULE_NAME="fonts"
+
+function preinstall() {
+ # TODO: Check if these are installed
+ PACKAGES+=("adobe-source-code-pro-fonts" "gnu-free-fonts" "noto-fonts" "noto-fonts-cjk" "noto-fonts-emoji" "noto-fonts-extra" "ttf-liberation")
+}
diff --git a/modules/30-rust/install.sh b/modules/30-rust/install.sh
new file mode 100644
index 0000000..76df8df
--- /dev/null
+++ b/modules/30-rust/install.sh
@@ -0,0 +1,16 @@
+_script="$(realpath ${BASH_SOURCE[0]})"
+_scriptname="$(basename $_script)"
+_scriptdir="$(dirname $_script)"
+_modulename="$(basename $_scriptdir)"
+DOT_MODULE_NAME="rustup"
+
+function preinstall() {
+ if ! [[ -x "$(command -v rustup)" ]]; then
+ PACKAGES+=("rustup")
+ fi
+}
+
+function install() {
+ log info "installing stable rust"
+ rustup install stable
+}
diff --git a/modules/40-neofetch/install.sh b/modules/40-neofetch/install.sh
index 81968ae..39ef2f2 100644
--- a/modules/40-neofetch/install.sh
+++ b/modules/40-neofetch/install.sh
@@ -19,5 +19,6 @@ function install() {
fi
log info "linking neofetch config"
+ mkdir -p "$HOME/.config/neofetch"
ln -f "$_scriptdir/config.conf" "$HOME/.config/neofetch/config.conf"
}